;----------------------------------------------------------------------------------
;ENTRY-FILE
;----------------------------------------------------------------------------------
;build for mega128 Fsys=18,32MHz

;time default motorschutz
.equ	COpro			=	100

;pwm process
.equ	allPHdw			=	0	;alle dw flag
.equ	allPHup			=	1	;alle up flag 
			

;key-flags
.equ	TOG1seq			=	0
.equ	TOG2seq			=	1
.equ	TOG3seq			=	2

;pin-definition
.equ	K0edge			=	3	;pine3
.equ	K1edge			=	4	;pine4
.equ	K2edge			=	5	;pine5
.equ	K3edge			=	6	;pine6
.equ	K4edge			=	7	;pine7

;pin wait states <keyWTstate>
.equ	K0wait			=	3	;
.equ	K1wait			=	4	;
.equ	K2wait			=	5	;
.equ	K3wait			=	6	;
.equ	K4wait			=	7	;

;--------------------------------------------------------------------------------------
;----------remote----------------------------------------------------------------------
;--------------------------------------------------------------------------------------
;statusflags
.equ	RTactivMstart	=	0
.equ	RTactivM		=	1
.equ	RTactivSstart	=	2
.equ	RTactivS		=	3

.equ	RTmaster		=	4	;full remote
.equ	RTgroup			=	5	;1= group remote access
.equ	RToff			=	6
.equ	RTon			=	7  ;full/group remote on/off


;remote flags f. remoteframer
.equ	sndREMon		=	0	;remote on-frame als master senden
.equ	sndREMoff		=	1	;remote off-frame als slave senden
.equ	sndREMactiv		=	2	;remote activ-frame als slave senden
.equ	sndREMspicode	=	3	;hif daten senden
.equ	sndREMspiflag	=	4	;hif flags senden
.equ	sndREMspiflagS	=	5	;hif flags + tablepointer senden

;remote hif-flags
.equ	toHIFrem		=	0	;=1 vom proz/prog-modul gel. hif daten anschlieend zum remote master 
.equ	fromHIFrem		=	1	;=1 vom master-hif gelieferte daten anschlieend zum slave 
.equ	HIFfailWT		=	2	;=1 warte auf frame von slave bis timeout

;remote fail counter	
.equ	remFAIL			=	300	;300	;0 ;9090 slots = 0,5s
.equ	remFAILmaster	=	250	;test
.equ	remFAILslave	=	1000
.equ	remFAILstB		=	3000	 ;

;group remote
.equ	groupFAIL		=	1050 ;1500 16*slottime*groupfail = 1,32s
;group remote wt
.equ	groupWT			=	800	;500


;dcf konstanten
.equ	ko2000dcf		=	8960 ;222s	/	9000 bei 2000 * 221s 
.equ	ko300dcf		=	1344 ;222s /   1350 bei 300 * 222s
.equ	ko999dcf		=	4659 ;222S /   4680 bei 999  * 222s
.equ	ko80dcf			=	358	;222s /    360	 bei 80   * 222s
.equ	ko180dcf		=	806	;222s /    810	 bei 180  * 222s

;flags:
.equ	dcf77sync		=	0	;sync-flag - dieses flag sperrt die interne rtc !!!!!
.equ	dcf77level		=	1	;signal-flag
.equ	dcf77high		=	3	;high-impuls
.equ	dcf77sumST		=	5	;start-sommerzeit
.equ	dcf77mesz		=	6	;sommerzeit mez+1
.equ	dcf77schalt		=	7	;schaltsekunde

.equ	dcf77_ms		=	0	;1ms flag (0x224) im timeslotmodul gesetzt
.equ	dcf1_s			=	1	;1s flag (0x224) im dcf77III modul gesetzt


;--------------------------------------------------------------------------------------
;--------- timer/counter konstanten & bit Definition ----------------------------------
;--------------------------------------------------------------------------------------

.equ	tiREL			= 	129	;257-((clock_f/8)/18018)	;155 <=>Fclk=14,7456Mhz ...146 <=> 16MHz)   
								;129 <=> Fclk 18,432000MHz (slottime = 55,5S / 1024 instr. je slot)
.equ	ser1K			=	1


;--------------------------------------------------------------------------------------
;----------------------------- tiFLAG bit definition ----------------------------------
;--------------------------------------------------------------------------------------


.equ	sekunde			=	0	;bit 0 wird als sekunden-flag genutzt (r27 <=> tiFLAG) ..wird getoggelt !!!!
.equ	help			=	1	;bit 1      "   help  -flag genutzt   (r27 <=> tiFLAG)
.equ	s100b			=	2	;bit 2      "   500ms help flag gen.  (r27 <=> tiFLAG)
.equ	s1s     		=   3   ;bit 3      "   1 sekunden flag       (r27 <=> tiFLAG)
.equ	s1ms  			=   4   ;bit 4      "   1ms falg              (r27 <=> tiFLAG)
.equ	s10msB			=	5	;bit 5	    "   10ms help flag	      (r27 <=> tiFLAG)


;--------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------
;------------------ powerrail flag definition ----------------------------------
;--------------------------------------------------------------------------------------


;0xcc

.equ	SHcut			=	7	;kurzschlu flag
.equ	portON			=	6	;port-on-flag
.equ	delOFF			=	5	;delayed-off-flag
.equ	softDW			=	4	;soft-down-flag
.equ	softUP			=	3	;soft-up-flag
.equ	railON			=	2	;power-rail-on-flag
.equ	senseON			=	1	;current-sense-on-flag
.equ	curON			=	0	;kurzschluberwachung an/aus-flag





;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;->SOFTWARE-FLAG-VARIABLEN
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;SEflagA <=> serial data communication flag variable
;********Flag's in SEflagA: 
.equ	SEbusy  	=	7	;<=> activ data communication
.equ	SEpassiv	=	6	;<=> data communication passiv 
.equ	SEsil   	=	5	;<=> silence on bus 
;				             SILwait =((10 * x)* CONbaud)* 55,3s<cycle_timeslot> 			   
.equ	RXframe 	=	4	;<=> new received data frame in buffer
.equ	TXframe 	=	3	;<=> new data frame to transmit
.equ	SEdir   	=	2	;<=> rx/tx ?
.equ	SEerror 	=	1	;<=> frame error
;
.equ	SEenabled	=	0	;<=> serial IF (dis-)enabled


;SEflagB <=> serial data communication flag variable
;********Flag's in SEflagB: 
.equ	SErepeat	=	7	;<=> repeatermode enabled
.equ	TXack		=	6	;<=> sende acknowledge...	
.equ	WTack		=	5	;<=> acknowledge von host erwartet...
.equ	newTX		=	2	;<=> signaliere new-data-frame-TX 
.equ	reqTX		=	1	;<=> "       "  request-data-tx
.equ	BRcast		=	0	;<=> broadcast frame received

;SEflagC <=> serial data communication flag variable
;********Flag's in SEflagC:

.equ	TXready			=	7	;<=> tx abgeschlossen (abhngig von TXC(ucsra)
.equ	FRbuild			=	6	;<=> framebuilder modifiert gerade rxbuffer
.equ	SERcomACT		=	5	;<=> allgemeine sercom aktivitt die den rxbuffer belegt...
.equ	SERwireless		=	4	;<=> wire-,(less) auswahlflag
.equ	STARTsequ		=	3	;<=> startsequenz
.equ	PRAEok			=	2	;<=> prambel erkannt
.equ	MANnibble		=	1	;<=> 0=erstes nibble en(de)coden  1=zweites nibble




;flags <fifoVAR>
.equ	fifoERR			=	0	;fifo error flag
.equ	fifoNEW			=	1	;fifo new-data flag
;----------------------------------------------------------------------------------------------------
;->DEFINITIONS SERcom.asm
;----------------------------------------------------------------------------------------------------
			
;......TWI
.equ	bitrate			=	80		;	standard 80					
.equ	prescal			=	0		;					
.equ	i2cout			=	100		;time out konstante 180

;twi-flags									
.equ	control			=	0		;control-flag (twi-STATUS)	   
.equ	TWIrequest		=	1		;request-flag (twi-STATUS)	
.equ	TWIinstr		=	2		;instruktion-flag (twi-STATUS)
.equ	adrmod			=	3		;adressierungsart			
.equ	adress			=	4		;adress-flag (twi-status)	
.equ	LHAreq			=	5		;transfer to LHA (request)
.equ    doTWI      		=   6       ;twi-aktion aktion noch abarbeiten
.equ	repSTART		=	7		;repeated start im request mode !

;twi-control-matrix
.equ	TWIstart		=	0x8		;twsr startmatrix				
.equ	TWIrep			=	0x10	;repeated start
.equ	slaW			=	0x18	;	"					
.equ	slaR			=	0x40	;	"					
.equ	rxACK			=	0x28	;   "
.equ	rxNACK			=	0x30	;	"
.equ	ARBerr			=	0x38	;arbitration lost...
.equ	txNACK			=	0x20	;nack
.equ	RECack			=	0x50
.equ	RECnack			=	0x58


;----------------------------------------------------------------------------------
;mi-Flags:
.equ	b_cast			=	7
.equ	repeat			=	6
.equ	request			=	5
.equ	adr_mod			=	4
.equ	trans1			=	3
.equ	trans0			=	2
.equ	requ1			=	1
.equ	requ0			=	0

;----------------------------------------------------------------------------------------------------
;->DEFINITIONS SERif.asm 
;----------------------------------------------------------------------------------------------------
.equ	praeFRAME			=	8	;8=14,4kbps // 10=19,2 bps							;lnge tx-prambel (6) bei 14,4k // lnge tx-prambel (10) == 4,68ms bei 19200bps / (13)3,12ms 28,8k
.equ	clock_f		    	=	18432000					;18,432MHz	
.equ	uart_baudrate		=   14400						;14400 best f.wireless
.equ	SETbaud		    	= 	(clock_f/(16*uart_baudrate))-1	;						
.equ	WToutVAR		    = 	25	;25	14,4k ;fifo timeout... ((1/baud)*9/slottime)*2,2
.equ 	CONbaud	  			=	2	;2/4 for use in 55,5s timeslot-system & 9600bps
.equ	xCON		    	=	3	;tx startdelay (kollisionsvermeidung !!!)
.equ	SILwait		    	=	(10 * xCON) * CONbaud		;sollte nicht in allen systemen gleich sein - daher x ! 
;NEW+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.equ	TIrxBYTE			=	1	;TEST1 ((TIrxBYTE * Framesize)+ net_sou_adress)* slottime = wartezeit auf acknowledge
.equ	wiWAIT				=	30	;{TEST30}   wiWAIT * slottime = rx/tx umschaltungs delay	
.equ	REPTXdef			=	2	;tx repeat // auch group access 
.equ	REPTXdefREM			=	0	;kein auto-tx-repeat bei remote 
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;FLAGS
.equ	showTD				=	1
.equ	calREADY			=	4

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;HOT SHOT
.equ	HSon				=	7	;hot shot enabled
.equ	HSdevEDI			=	6	;1=edit devive table // only possible after clear target instr. !
.equ	HSexe				=	5	;1=execute hotshot 



;flags
.equ	schaltFL			=	0	;schaltjahrflag
.equ	kalender			=	1	;kalender start
.equ	kalLOOP				=	2	;loop flag
;konstante
.equ	Wday				=	7	;wochentage
.equ	sixty				=	61	
;
;GLOBtim =      0x71	        	;global timer (de-)aktivierungsvariable
.equ	GLtim0				=	0	;global timer flag 0
.equ	GLtim1				=	1	;   "          "   1
.equ	GLtim2				=	2	;   "          "   2
.equ	GLtim3				=	3	;   "          "   3	
;
;FLAGS
.equ	t1ms0FLAG			=	0
.equ	t1ms1FLAG			=	1
.equ	t1ms2FLAG			=	2
.equ	t1ms3FLAG			=	3

;FLAGS
.equ	comp0activ			=	0
.equ	comp1activ			=	1
.equ	comp2activ			=	2
.equ	comp3activ			=	3
.equ	comp4activ			=	4
.equ	comp5activ			=	5
.equ	comp6activ			=	6
.equ	comp7activ			=	7



;

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;spi-glcd flags
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; SPI
.equ	_SS				=	0	;pb0
.equ	MOSI			=	2	;pb2
.equ	MISO			=	3	;pb3
.equ	SCK				=	1	;pb1

;.............................................................................
;--------------------------------------------------------------------------------------
;HIF Flags
;--------------------------------------------------------------------------------------
;...........................................................................
;para-Function flag
.equ	ediG			=	7		;
.equ	parG			=	6		;-> flag...
;...........................................................................
;comFLAGspi's 0x23f
.equ	newSPIdata		=	0		;neue daten empfangen
.equ	spiBUSY			=	1		;transfer aktiv
.equ	spiMready		=	2		;master ready
.equ	newSPIsnd		=	3		;neue daten senden
.equ	exeSPIdata		=	4		;neue daten ausfhren
.equ	repSPItrPZ		=	5		;gesetzt bei spiBUSY & neue pz-daten zum versand...
.equ	repSPItrPR		=	6		;gesetzt bei spiBUSY & neue pr-daten zum versand...
.equ	spiWORKIN		=	7		;spi routine aktiv

;...........................................................................
;comFLAGspiREM
.equ	newSPIdataR		=	0		;neue daten im rem-master hif generiert und im slave verarbeiten
.equ	newSPIsndR		=	1		;neue daten im rem-slave generiert und im master verarbeiten 


;******************************************************************************************
;OBJECT DEFINITIONS
;******************************************************************************************
;siehe memMAP...

.equ	SYSeolSUB		=	32768	;konstante
;........................................................................
;flags(
.equ	errOB		=	0
.equ	newOB		=	1

;*******************************************************************************************
;programmplatzspeicher 
;E2prom  0x150-0x1F0 (im laufenden betrieb erforderlich)

;FLAG'S:
.equ	runMTX		=	0		;run matrix 	== 	mu zusammen mit programmplatz
;(0x146) an matrix - routine bergeben werden
.equ	same0		=	1 		;(0x146)
.equ	same1		=   2
.equ	same2		=	3
.equ	same3		=	4
.equ	makeMTX		=	5		;bergebe aktive sollparameter an macro
.equ	wrMTX		=	6		;schreiben aktiv !
.equ	same		=	7		;vergleichsflag	==	interne verarbeitung (timer/programm) 	

;******************************************************************************************* 
;progOB konstanten
.equ	kon50tsd	=	50000
.equ	kon10tsd	=	10000
.equ	kon5tsd		=	5000
.equ	kon1tsd		=	1000
.equ	kon1hun		=	100
.equ	kon5hun		=	500
.equ	kon5zig		=	50
.equ	kon1zehn	=	10

;----------------------------------------------------------------
;----------- Register Definition --------------------------------
;----------------------------------------------------------------
;Reservierte Register:
.def	tiFLAG	=	r27	;globale Zeitmarkenregister



;----------------------------------------------------------------
;interrupt adressen
;----------------------------------------------------------------

.cseg
.org	0
	;------------------> jump table fuer atmega128!!!
	jmp	init			   ;RESaddr =0x000	;Reset vector Adress
;**** Interrupt Vectors ****
;.equ	INT0addr  = $002	; External Interrupt0 Vector Address
;.equ	INT1addr  = $004	; External Interrupt1 Vector Address
;.equ	INT2addr  = $006	; External Interrupt2 Vector Address
;.equ	INT3addr  = $008	; External Interrupt3 Vector Address
;.equ	INT4addr  = $00a	; External Interrupt4 Vector Address
;.equ	INT5addr  = $00c	; External Interrupt5 Vector Address
;.equ	INT6addr  = $00e	; External Interrupt6 Vector Address
;.equ	INT7addr  = $010	; External Interrupt7 Vector Address
;.equ	OC2addr   = $012	; Output Compare2 Interrupt Vector Address
;.equ	OVF2addr  = $014	; Overflow2 Interrupt Vector Address
;.equ	ICP1addr  = $016	; Input Capture1 Interrupt Vector Address
;.equ	OC1Aaddr  = $018	; Output Compare1A Interrupt Vector Address
;.equ	OC1Baddr  = $01a	; Output Compare1B Interrupt Vector Address
;.equ	OVF1addr  = $01c	; Overflow1 Interrupt Vector Address
;.equ	OC0addr   = $01e	; Output Compare0 Interrupt Vector Address
;.equ	OVF0addr  = $020	; Overflow0 Interrupt Vector Address
.org	0x20
	jmp	_tiSLOT	
;.equ	SPIaddr   = $022	; SPI Interrupt Vector Address
.org	0x22
	jmp	SPI_SLAVE
;.equ	URXC0addr = $024	; USART0 Receive Complete Interrupt Vector Address
.org	0x24			
	jmp	uartINTrx

;.equ	UDRE0addr = $026	; USART0 Data Register Empty Interrupt Vector Address
;.equ	UTXC0addr = $028	; USART0 Transmit Complete Interrupt Vector Address
;.equ    ADCCaddr  = $02a	; ADC Conversion Complete Handle
;.equ	ERDYaddr  = $02c	; EEPROM Write Complete Handle
;.equ	ACIaddr   = $02e	; Analog Comparator Interrupt Vector Address
;.equ	OC1Caddr  = $030	; Output Compare1C Interrupt Vector Address
;.equ	ICP3addr  = $032	; Input Capture3 Interrupt Vector Address
;.equ	OC3Aaddr  = $034	; Output Compare3A Interrupt Vector Address
;.equ	OC3Baddr  = $036	; Output Compare3B Interrupt Vector Address
;.equ	OC3Caddr  = $038	; Output Compare3C Interrupt Vector Address
;.equ	OVF3addr  = $03A	; Overflow3 Interrupt Vector Address
;.equ	URXC1addr = $03C	; USART1 Receive Complete Interrupt Vector Address
;.equ	UDRE1addr = $03E	; USART1 Data Register Empty Interrupt Vector Address
;.equ	UTXC1addr = $040	; USART1 Transmit Complete Interrupt Vector Address
;.equ    TWIaddr   = $042	; TWI Interrupt Vector Address
;.equ	SPMRaddr  = $044	; Store Program Memory Ready Interrupt Vector Address


;----------------------------------------------------------------------
;init counters,stack,timer...
;----------------------------------------------------------------------
.org	0x4a
init:
	;stack
	ldi	r16,high(ramend)
	out	sph,r16
	ldi	r16,low(ramend)
	out	spl,r16
	
	;+++++++++++++++++++++++++++++++++++++++++++
	;disable jtag IF
	in	r16,mcucsr
	sbr	r16,1<<jtd
	out	mcucsr,r16
	nop
	out	mcucsr,r16



;-------------------clear sram complete 0x100 headroom ! ----------------------------------------------------------------------------
	clr	r16
	ldi	zh,high(sram_start)
	ldi	zl,low(sram_start)	;sram startadresse(0x100)
_CLRsram:
	st	z+,r16	
	cpi	zl,low(ramend)		;Compare low byte
	ldi	r17,high(ramend)	;
	cpc	zh,r17				;Compare high byte
	breq	_SRAMready
	jmp	_CLRsram
	;
_SRAMready:
;-----------------------------------mirror e2prom -> sram ------------------------------------


;		  *	0x000  	 	    	= 	entry pin
;		  +	0x001				= 	lha
			.equ	net_se2p	=	0x1
;		  +	0x002	-	0x005	=	powerdelays
;		  +	0x006	- 	0x014	=	timer0-3
;		  +	0x015	-	0x01e	=	delay 0-9 / ev-delay 0&1
;		  + 0x01f 	- 	0x026  	= 	port-aktiv-bytes 	
;		  *	0x027         		= 	adc-max-current-var
			.equ	adcHYSe2p	=	0x27	
;		  +	0x028 	- 	0x02f  	= 	compare-max 0-7 
;		  +	0x030	-	0x037	=	compare-ist 0-7
;		  +	0x038 	- 	0x049  	= 	compare-timers & counters 
;		  +	0x04a	- 	0x067 	= 	switchport-variablen 
;		  * 0x068	-	0x1a7	=	macro-matrix
			.equ	proE2ADR	=	0x68 
;		  +	0x1a8 	- 	0x35f	= 	dma-profiles
;		  +	0x360 	- 	0x48b	= 	object-class-table out
;		  +	0x48c	- 	0x611	= 	object-classfilter-table in
;		  + 0x612	- 	0x76a	=   key-sequencer
;		  - 0x76b   -   0x800	=   FREE
;- = nicht belegt
;+ = kopiere beim booten
;* = dynamisches laden
;------------------------------------------------------------------------------------------


;
;range...n-1 (anzahl bytes -1)
.equ	_mirA	=	0x10		;timer 0-3
.equ	_mirB	=	0x8			;delay 0-7
.equ	_mirC 	=   0x8			;compare max. 0-7 / ist 0-7
.equ	_mirD 	=   0x8			;port aktivbytes
.equ	_mirF	=	0x1e		;virt_port 0-29
.equ	_mirG	=	0x1			;lha
.equ	_mirH	=	0x1b8		;profilframer..
.equ	_mirI	=	0xa			;compare timer
.equ	_mirJ	=	0x2			;eventdelay
.equ	_mirK	=	0x4			;powerdelays
.equ	_mirL	=	0x6			;comparetimer 5..7
;----------------------------------------------------------
	;+net_sou_adress
__mirrorAX:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(net_se2p)
	ldi	r24,low(net_se2p)		
	ldi	zh,high(net_sou_adress)
	ldi	zl,low(net_sou_adress) 	;
	ldi	r19,_mirG		;max range 1
	call	_MIrrore2
;-------------------------------------

	;+timer1-4
__mirrorA:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(timerE2adr)
	ldi	r24,low(timerE2adr)			;mirror - e2prom start
	ldi	zh,high(minut1)
	ldi	zl,low(minut1) 	;mirror - sram start	
	ldi	r19,_mirA		;max range
	call	_MIrrore2

	;
	;+delay0-7
__mirrorB:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(delE2adrA)
	ldi	r24,low(delE2adrA)		;mirror - e2prom start
	ldi	zh,high(delay0)
	ldi	zl,low(delay0) 	;mirror - sram start	
	ldi	r19,_mirB		;max range
	call	_MIrrore2
	;
	;+power delays 1-4
__mirrorBY:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(delE2adrB)
	ldi	r24,low(delE2adrB)		;mirror - e2prom start
	ldi	zh,high(Pdelay1)
	ldi	zl,low(Pdelay1) 	;mirror - sram start	
	ldi	r19,_mirK		;max range
	call	_MIrrore2
	;
	;+ev-delay 0&1
__mirrorBX:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(delE2adrC)
	ldi	r24,low(delE2adrC)		
	ldi	zh,high(TI1evsoll)
	ldi	zl,low(TI1evsoll) 
	ldi	r19,_mirJ		;max range
	call	_MIrrore2

;-----------------------------------------------

	;+CmaxA...D 
	;blends /counter compare
__mirrorC:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(CmaxE2p)
	ldi	r24,low(CmaxE2p)		;mirror - e2prom start
	ldi	zh,high(CmaxA)
	ldi	zl,low(CmaxA) 	;mirror - sram start	
	ldi	r19,_mirC		;max range
	call	_MIrrore2

	;+Cist1...8
	;blends /counter compare
__mirrorCY:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(CistE2p)
	ldi	r24,low(CistE2p)		;mirror - e2prom start
	ldi	zh,high(CpareI1)
	ldi	zl,low(CpareI1) 	;mirror - sram start	
	ldi	r19,_mirC		;max range
	call	_MIrrore2

	;+Csoll 1...8 == ist
	;blends /counter compare
__mirrorCYY:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(CistE2p)
	ldi	r24,low(CistE2p)		;mirror - e2prom start
	ldi	zh,high(CpareA)
	ldi	zl,low(CpareA) 	;mirror - sram start	
	ldi	r19,_mirC		;max range
	call	_MIrrore2

;--------------------------------------------------------------
	;
	;+aktiv-port
__mirrorD:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(aktE2adr)
	ldi	r24,low(aktE2adr)		;mirror - e2prom start
	ldi	zh,high(akt1)
	ldi	zl,low(akt1)	;mirror - sram start	
	ldi	r19,_mirD		;max range
	call	_MIrrore2


;----------------------------------------------------------------
	;+switch-port
__mirrorG:	
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(softPo0ep)
	ldi	r24,low(softPo0ep)	;mirror - e2prom start
	;
	ldi	zh,high(softPo0)
	ldi	zl,low(softPo0)		;mirror - sram start	
	;
	ldi	r19,_mirF			;max range
	call	_MIrrore2

;----------------------------------------------------------------
	;+dma-profiles
__mirrorH:	
	clr	yl
	clr	yh
	ldi	r25,high(profiSTe2p)
	ldi	r24,low(profiSTe2p)	;mirror - e2prom start
	;
	ldi	zh,high(profiSTram)
	ldi	zl,low(profiSTram)	;mirror - sram start	
	;
	ldi	r19,low(_mirH)		;max range
	ldi	r18,high(_mirH)
	call	_MIrrore2
;----------------------------------------------------------------
	;+compare timer 0-4 
__mirrorI:	
	clr	yl
	clr	yh
	ldi	r25,high(comTIMe2adr)
	ldi	r24,low(comTIMe2adr)	;mirror - e2prom start
	;
	ldi	zh,high(timeUP0low)
	ldi	zl,low(timeUP0low)	;mirror - sram start	
	;
	ldi	r19,low(_mirI)		;max range
	ldi	r18,high(_mirI)
	call	_MIrrore2

	;+compare timer 5-7 & dw-timer
__mirrorIX:	
	clr	yl
	clr	yh
	ldi	r25,high(comTIMe2adrB)
	ldi	r24,low(comTIMe2adrB)	;mirror - e2prom start
	;
	ldi	zh,high(timeUP5low)
	ldi	zl,low(timeUP5low)	;mirror - sram start	
	;
	ldi	r19,low(_mirL)		;max range
	ldi	r18,high(_mirL)
	call	_MIrrore2






;---------------------------------------------------------------
	;+class_define (out)
__mirrorJ:	
	clr	yl
	clr	yh
	ldi	r25,high(class_defineEEPROM)
	ldi	r24,low(class_defineEEPROM)	;mirror - e2prom start
	;
	ldi	zh,high(class_define)
	ldi	zl,low(class_define)		;mirror - sram start	
	;
	ldi	r19,low(class_def_SIZ)		;max range
	ldi	r18,high(class_def_SIZ)
	call	_MIrrore2
;---------------------------------------------------------------
	;+class_filter_def (in)
__mirrorK:	
	clr	yl
	clr	yh
	ldi	r25,high(class_filter_defEEPROM)
	ldi	r24,low(class_filter_defEEPROM)	;mirror - e2prom start
	;
	ldi	zh,high(class_filter_def)
	ldi	zl,low(class_filter_def)		;mirror - sram start	
	;
	ldi	r19,low(class_fil_SIZ)			;max range
	ldi	r18,high(class_fil_SIZ)
	call	_MIrrore2

;---------------------------------------------------------------
	;+key-sequencer
__mirrorL:	
	clr	yl
	clr	yh
	ldi	r25,high(keyTBLstart_e2p)
	ldi	r24,low(keyTBLstart_e2p)	;mirror - e2prom start
	;
	ldi	zh,high(keyTBLstart)
	ldi	zl,low(keyTBLstart)		;mirror - sram start	
	;
	ldi	r19,low(keyTBLsiz)			;max range
	ldi	r18,high(keyTBLsiz)
	call	_MIrrore2

;---------------------------------------------------------------
	;+lha_id
__mirrorLX:	
	clr	yl
	clr	yh
	ldi	r25,high(lha_id_tble2p)
	ldi	r24,low(lha_id_tble2p)	;mirror - e2prom start
	;
	ldi	zh,high(lha_id_tbl)
	ldi	zl,low(lha_id_tbl)		;mirror - sram start	
	;
	ldi	r19,low(lha_id_range)			;max range
	ldi	r18,high(lha_id_range)
	call	_MIrrore2



;----------------------------------------------------------------
	;+group tbl //adress 1
__mirrorM:	
	clr	yl
	clr	yh
	ldi	r25,high(group_id_tbl)
	ldi	r24,low(group_id_tbl)	;mirror - e2prom start
	;
	ldi	zh,high(temp_para_tbl)
	ldi	zl,low(temp_para_tbl)		;mirror - sram start	
	;
	ldi	r19,low(_mirG)			;max range
	ldi	r18,high(_mirG)
	call	_MIrrore2

	;+group tbl //adress 2
__mirrorN:	
	clr	yl
	clr	yh
	ldi	r25,high(group_id_tbl)
	ldi	r24,low(group_id_tbl)		;mirror - e2prom start
	adiw	r25:r24,lha_id_range	;7bytes
	;
	ldi	zh,high(temp_para_tbl)
	ldi	zl,low(temp_para_tbl)		;mirror - sram start
	adiw	zh:zl,temp_para_segSIZ	;9bytes	
	;
	ldi	r19,low(_mirG)			;max range
	ldi	r18,high(_mirG)
	call	_MIrrore2
	;+group tbl //adress 3
__mirrorO:	
	clr	yl
	clr	yh
	ldi	r25,high(group_id_tbl)
	ldi	r24,low(group_id_tbl)			;mirror - e2prom start
	adiw	r25:r24,lha_id_range*2		;14bytes
	;
	ldi	zh,high(temp_para_tbl)
	ldi	zl,low(temp_para_tbl)			;mirror - sram start
	adiw	zh:zl,temp_para_segSIZ*2	;18bytes	
	;
	ldi	r19,low(_mirG)					;max range
	ldi	r18,high(_mirG)
	call	_MIrrore2

	;+group tbl //adress 4
__mirrorP:	
	clr	yl
	clr	yh
	ldi	r25,high(group_id_tbl)
	ldi	r24,low(group_id_tbl)			;mirror - e2prom start
	adiw	r25:r24,lha_id_range*3		;21bytes
	;
	ldi	zh,high(temp_para_tbl)
	ldi	zl,low(temp_para_tbl)			;mirror - sram start
	adiw	zh:zl,temp_para_segSIZ*3	;27bytes	
	;
	ldi	r19,low(_mirG)					;max range
	ldi	r18,high(_mirG)
	call	_MIrrore2

	;+group tbl //adress 5
__mirrorQ:	
	clr	yl
	clr	yh
	ldi	r25,high(group_id_tbl)
	ldi	r24,low(group_id_tbl)			;mirror - e2prom start
	adiw	r25:r24,lha_id_range*4		;28bytes
	;
	ldi	zh,high(temp_para_tbl)
	ldi	zl,low(temp_para_tbl)			;mirror - sram start
	adiw	zh:zl,temp_para_segSIZ*4	;36bytes	
	;
	ldi	r19,low(_mirG)					;max range
	ldi	r18,high(_mirG)
	call	_MIrrore2

	;adc sensoric cross table
__mirrorR:
	clr	yl
	clr	yh
	ldi	r25,high(adcSENSE_paraTBL)
	ldi	r24,low(adcSENSE_paraTBL)	;mirror - e2prom start
	;
	ldi	zh,high(ADC16_SA1H)
	ldi	zl,low(ADC16_SA1H)		;mirror - sram start	
	;
	ldi	r19,low(_mirD)			;max range
	ldi	r18,high(_mirD)
	call	_MIrrore2
	jmp	_MIRready






;--------------------------------------------------------------------------
_MIrrore2:
	sbic	eecr,eewe		; eepe nicht gelscht ?
	rjmp	_MIrrore2		; warte...
	out		eearh,r25 
	out		eearl,r24		; adressierung e2prom
	sbi		eecr,eere		; bereite bertragung aus e2prom vor 
	in		r2,eedr			; kopiere daten aus e2prom nach r2
	st		z+,r2			;sram adr+1
	adiw 	r25:r24,1		;e2promadresse +1
	;range-1
	subi	r19,low(ser1K)
	sbci	r18,high(ser1K)
	;0?
	cp		yl,r19
	cpc		yh,r18			;nur bis ..mirror range
	brne	_MIrrore2
	ret


;-----------------------------------------------------------------------------------
;new ATmega128
_MIRready:

	;portA  Sek. output 
	;a)state: all pins L
	clr	r16
	out	porta,r16
	;b)direction: all pins output
	ldi	r16,0xff
	out	ddra,r16	

	;------------------------------------------
	;portB SPI(PB0..3)/PWM(PB5)/GLCD-RESET(PB6)
;	ldi	r16,0b10011111
;	out	portb,r16
;	ldi	r16,0b01100000
;	out	ddrb,r16
	;-----------------------------------------
	;DISABLE GLCD
	cbi	portb,portb6
	;set portb,pinb5 out
	sbi	ddrb,ddb5

	;-----------------------------------------
	;portC  Prim. output
	;a)state: all pins low
	clr	r16
	out	portc,r16
	;b)direction: all pins output
	ldi	r16,0xff
	out	ddrc,r16


	;-----------------------------------------
	;portD   TWI(PD0,1)/UART1(PD2..PD4)/TRIGGER(PD6)/DCF(PD7)
	clr	r16			;testen.. eventuell PD6/PD7 pullup!
	sbr	r16,1<<7
	out	portd,r16
	ldi	r16,0b00010000
	out	ddrd,r16


	;-----------------------------------------
	;portE   UART0(PE0..PE2)/KEYS(PE3...PE7)
	;+++TEST
	;clr	r16
	ldi	r16,0b00000011		
	out	porte,r16
	ldi	r16,0b00000100
	out	ddre,r16

	
	;-----------------------------------------
	;portF   ADC(PF0..PF3)/JTAG(PF4...PF7)
	ldi	r16,0xf0
	sts	portf,r16
	clr	r16
	sts	ddrf,r16


	;-----------------------------------------
	
	;timer0 overflow-interrupt alle 55,5s
	;Fck(18,432000Mhz)/8= 2304000Hz/128=18000Hz <=> 1/18000 = 55,5s
	;
	;tiREL=(256+1)-128=129
	clr	r16
	sbr	r16,1<<toie0	;enable overflow interrupt
	out	timsk,r16
	clr	r16
	sbr	r16,1<<cs01	
	out	tccr0,r16		;prescale /8
	
	ldi	r16,tiREL		;s reload 
	out	tcnt0,r16
	;


	;-------------------------------------------------------------------------------------------
	;		  				 _______________________________________________________________
	;timer1/counter control:|com1A1 |com1A0 |com1B1 |com1B0 |foc1A  |foc1B  |wgm11  |wgm10  |
	;tccr1A		 			|_______|_______|_______|_______|_______|_______|_______|_______|
	;		           
	;
	;		  		 		 _______________________________________________________________
	;timer1/counter control:|icnc1  |ices1  |-      |wgm13  |wgm12  |cs12   |cs11   |cs10   |
	;tccr1B		 			|_______|_______|_______|_______|_______|_______|_______|_______|
	;		           
	;
	;
	;timer1 pwm-mode auf pin ocr1a!
	ldi	r16,0b10000001		;init ocr1a (choose 8-Bit PWM etc...)
	out	tccr1a,r16

	ldi	r16,0b00000001		;init PWM...mode1 / phase correct / (choose fclk/0!)
	out	tccr1b,r16
		
	ldi	r16,0			;default wert 0	
	out	ocr1ah,r16			
	out	ocr1al,r16
	out	tcnt1l,r16
	out	tcnt1h,r16


	;------------------------------------------------------------------------------------
	;flag lschen
	clr	tiFLAG


_evINI:
	;trigger-device init
	ldi	r16,4
	sts	DEVICEcnt,r16	;
	ldi	r22,180		;default
	sts	PHASEbkup,r22
	;timebase compare 120*1ms
	ldi	zh,0
	sts	timeDWhigh,zh
	ldi	zl,120	;test
	sts	timeDWlow,zl

	;startwert f. prog-auswahltexte
	clr	r16
	sts	auswahlCNT,r16

		;..........................................
		;events neu
;		ldi	r23,11
;		sts	eventTE,r23			;power up event setzen
;		call	_MAKEeventSUB	;submodul !
		;..........................................
	;blend states
	clr	r20
	sts	DEVUDstate,r20
	sts	DEVONstate,r20
	;
	;
	;matrix dafault-werte 
	clr	r20
	sts	matrix_flag,r20		;
	ldi	r20,high(phase1)
	sts	takti_adrBH,r20	;lade mit aktivbyte startadresse 
	ldi	r20,low(phase1)
    sts	takti_adrBL,r20	;lade mit aktivbyte startadresse 	
	;startadresse pindriver	
	ldi	r20,high(akt1)
	sts	PINcntH,r20
	ldi	r20,low(akt1)
	sts	PINcntL,r20
	;slot 1 beginnen
	ldi	r26,1 
	sts	slotCNT,r26		;timeslot-counter initialisieren
	;
	;initialisiere power-flag's 
;	ldi	r20,1		;kurzschlusicherung ein !!!
	clr	r20
	sts	PWRflag,r20	;powerrail aus ... mu manuell wieder gestartet werden !
	;

;---------------------------------------------------------------------------------------------	
;adc init
;;--------------------------------------------------------------------------------------------
;* ADC-Multiplexer (ADMUX) - Tabelle :
; _______________________________________________
;|     |     |     |     |     |     |     |     |
;|refs1|refs0|adlar|mux4 |mux3 |mux2 |mux1 |mux0 |
;|_____|_____|_____|_____|_____|_____|_____|_____|
;
;refs1= 0 + refs0= 0 	== AREF (int.Ref off)
;refs1= 1 + refs0= 1 	== int.REF 2,56V (ext.Cap an AREF-Pin)
;
;
;adlar= 0  			== adc result right adjust (... default)
;adlar= 1			==            left adjust
;
;
;mux4 wird nur in speziellen modes (differential, gain-adjust...) verwendet
;
;--------------------------------------------------------------------------------------------
;* ADC-Control-,und Status-RegisterA (adcsr) - Tabelle :
; _______________________________________________
;|     |     |     |     |     |     |     |     |
;|aden |adsc |adate|adif |adie |adps2|adps1|adps0|
;|_____|_____|_____|_____|_____|_____|_____|_____|
;
;aden= 0 			== adc disabled
;aden= 1		 	== "   enabled
;
;
;adsc= 0  			== no affect
;adsc= 1			== start coversation 
;
;
;adate=0			== auto trigger disabled (siehe SFIOR settings !!!)
;adate=1			== "       "    enabled
;
;
;adif=0/1			== adc interrupt flag (set/cleared by hardware..)-> write 1 to clear
;
;
;adie=0				== adc interrupt disabled
;adie=1				== "         "   enabled
;
;
;adps0..2			== trigger prescaler Fclk:2/4/8/16/32/64/128 
;
;--------------------------------------------------------------------------------------------
;* Special-Function-Register (SFIOR) - Tabelle :
; _______________________________________________
;|     |     |     |     |     |     |     |     |
;|adts2|adts1|adts0|adhsm|acme |pud  |psr2 |psr10|
;|_____|_____|_____|_____|_____|_____|_____|_____|
;
;adts2 	adts1  	adts0
;0		0		0	== free running mode
;0		0		1	== analog comparator
;0		1		0	== external interrupt request 0
;0		1		1	== timer0 compare match
;1		0		0	== timer0 overflow
;1		0		1	== timer compare match B
;1		1		0	== timer1 overflow
;1		1		1	== timer1 capture event
;
;--------------------------------------------------------------------------------------------
;folgende adc-kanle werden 
;adc3(pf3) == analogD 
;adc2(pf2) == analogC
;adc1(pf1) == analogB
;adc0(pf0) == analogA

	ldi	r16,0b10010111		;no free-running-converation...
	out	adcsr,r16	
	;
	ldi	r16,0b01000000      ;ext.Vref&cap, mux0
	out	admux,r16			;bei interner Vref == 0xc4 !!!
	;
	ldi	r16,0
	sts	cntLOOP,r16			;adc-mux start channel4
;---------------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
	
	;serielle kommunikation initialisieren
	;zuerst einen definierten zustand schaffen
	;
	;serIF aktivieren
	;if-software enabled
	clr	r19
	sbr	r19,1<<SEenabled
	sbr	r19,1<<SEbusy	;TEST cbr
	sts	SEflagVARa,r19
	;
	ldi	r16,WToutVAR
	sts	WToutRX,r16		;timeout preset !!!
	;
	ldi	r19,SETbaud		;baud konst. laden
	out	ubrr0l,r19
;	clr	r19
;	out	ubrr0h,r19
	;


	clr	r19
	sts	matrixCNT,r19
	sts	SEflagVARb,r19
	sbr	r19,1<<TXready
	;default == wireless
	sbr	r19,1<<SERwireless	
	sts	SEflagVARc,r19
	;TEST-deaktivieren !
	ldi	r19,(1<<rxen0)|(1<<rxcie0)
	out	ucsr0b,r19	


	ldi	r19,1<<txc0
	out	ucsr0a,r19
	cbi	porte,pine2		;rs485 transceiver rx/sby  
	;dummy
	in	r19,udr0
	;
	;init fifo by entry module
	clr		r16
	sts		fifoIN,r16
	sts		fifoOUT,r16
	sts		fifoVAR,r16
	;
	clr	r16
	sts		WIREset,r16
	;
	ldi	r18,wiWAIT	
	sts	ToutACK,r18	
	;
	ldi	r18,SILwait
	sts	WTsil,r18
	;
	;twi initialisieren
	;defaults: - bitrate 80
	;		   - prescale 0		
	;<=> 24,39Kbit/s max.   
	;
	ldi	r16,bitrate
	sts	twbr,r16
	lds	r16,twsr
	cbr	r16,1<<twps0
	cbr	r16,1<<twps1
	sts	twsr,r16
	;stop condition
	ldi	r21,(1<<twint)|(1<<twen)|(1<<twsto)
	sts	twcr,r21
	;
	;
	;repeatCNT definieren
	;19-12-03
	;-> TX wiederholungssequenz
	ldi	r20,4
	sts	repeatCNT,r20
	;
	;- kalender -
	;default datum
	ldi	r20,1
	sts	tageS,r20
	sts	monatS,r20
	ldi	r20,4
	sts	jahrS,r20
	clr	r20
	sbr	r20,1<<kalender
	sts	dateVAR,r20
	clr	r20
	sts	dateLOOP,r20
	ldi	r20,200
	sts	kalcount,r20
	;
	;datum noch nicht komplett
	clr	r22
	sts	rtcFLAG,r22

	;dcf77
	clr	r20
	sts	dcf77_status,r20
	sts	time1msFL,r20
	sts	dcf77_psc,r20
	sts	dcf77_levCTlow,r20
	sts	dcf77_levCThigh,r20
	sts	dcf77_sekunde,r20
	;
	;display variablen-default
	ldi	r20,120
	sts	teDISbr,r20
	ldi	r20,55
	sts	teDISco,r20
	;startup text im hif
	;comFLAGspi's
	clr	r20
	sts	pzHIF,r20
	sts	prHIF,r20
	sts	prozPSC,r20
	sts	progPSC,r20
	sts	comFLAGspi,r20

	;key edge status default == high (pulled up)
	ldi	r20,0xff
	sts	keyEDGE,r20

	;-----------------------------------------
	;ENABLE GLCD
	sbi	portb,portb6
	
	;object state
	;status auf=0
	clr		r20
	sts		object_state,r20
	;event = 1
	ldi		r20,1
	sts		temp_event,r20
	;objekt-counter =0
	clr		r20
	sts		object_counter,r20

	;hot shot state = on
	clr		r20
	sbr	r20,1<<HSon
	sts	HOTstate,r20

;-------------------------------------------
; startup delay
;-------------------------------------------
_STdel:
	ldi	r18,40
_STdLOOP:
	tst	r18
	breq	_STback
	dec	r18
	ldi	r16,0xff
	ldi	r17,0xff
	jmp	_STdelA

_STback:
	jmp	_evLOOPa
;
_STdelA:
	tst	r16
	breq	_STdelB
	dec		r16
	jmp	    _STdelA
_STdelB:
	tst	r17
	breq	_STdLOOP
	dec	r17
	ldi	r16,0xff
	jmp	_STdelA


;-----------------------------------------------------------------------------------------
;------- warteschleife bis zum nchsten interrupt ----------------------------------------
;-----------------------------------------------------------------------------------------


_evLOOPa:
	sei
	;watchdog enabled
	clr	r28
	sbr	r28,1<<wde
	out	wdtcr,r28
_evLOOP:
	lds	zl,ALLtiming1L
	lds	zh,ALLtiming1H	
	adiw	zh:zl,1
	sts	ALLtiming1L,zl
	sts	ALLtiming1H,zh
;	nop
	jmp	_evLOOP


.include "m128MODdef.inc"			;sram=4k   e2prom=4k   flash=128k	 
.include "memMAP.inc"			 	 ;memory-map 
.include "RTC.asm"
.include "TImeslotII.asm"
.include "DEVdriver.asm"
.include "CURadc.asm"
.include "Process_v05HIF.asm"
.include "PROG16ob.asm"
.include "PROG16obSEC_XM1_2.asm"
.include "KOMmatrix.asm"
.include "H_speedtrigger_II.asm"
.include "PWRrail.asm"	
.include "SERifII.asm"
.include "serCOM16_IIob.asm"	
.include "rtcDATE.asm"	
.include "uart_fifo.asm"
.include "virtPORT.asm"
.include "dcf77IV.asm"
.include "object_framer.asm"
.include "spi_M.asm"
.include "spi_int.asm"
.include "spi_INI.asm"
.include "objekt_ap.asm"
.include "SYSsub.asm"
.include "_keySEQ.asm"
.include "remoteII.asm"
.include "manchester_codec.asm"
.include "HOTshot.asm"
.include "COMPEX.asm"
.include "table_new_XM1_2.asm"
.include "table_new_XM1_3.asm"
.exit
