;**************************************************************
;REMOTE-modul (dynamisch)
;**************************************************************
;master->slave remote control
;.............................................................
;variablen:
;remCNT			= ablaufcounter 
;remFLAG		= remote-status-flags 
;remMASTER		= masteradresse (LHA) 
;remSLAVE		= slaveadresse  (LHA) 
;remGLOBflag	= globale flagvariable 





;------------------------------------------------------------------
;remote-flags(remFLAG	):
;RTmaster	=	0	;versetzt modul in mastermode
;RTactivS	=	1	;versetzt modul in slavemode
;RTon		=	2	;remotemode (on/off)
;RTactivM	=	3	;remote luft - besttigung vom slave
;
;
;event-flags(remEVflag)
;sndREMon		=	0	;remote on-frame als master senden
;sndREMoff		=	1	;remote off-frame als slave senden
;sndREMactiv	=	2	;remote activ-frame als slave senden
;sndREMspicode	=	3	;hif daten als master senden
;sndREMdisplay	=	4	;hif displaydaten als slave senden
;------------------------------------------------------------------
;INFO:Die Koie liegt am Ende des SPI-Buffers
;comFLAGspi /kopie <->HIFremFL  (SPIstring 0x581)+ 0x5b
;newSPIdata	=	0		;neue daten empfangen
;spiBUSY	=	1		;transfer aktiv
;spiMready	=	2		;master ready
;newSPIsnd	=	3		;neue daten senden
;exeSPIdata	=	4		;neue daten ausfhren
;repSPItrPZ	=	5		;gesetzt bei spiBUSY & neue pz-daten zum versand...
;repSPItrPR	=	6		;gesetzt bei spiBUSY & neue pr-daten zum versand...
;
;remFAIL	=	9090	;0,5 s
;remFAILcntL/H	= fail counter	
;------------------------------------------------------------------
;HIFteREMfl <=> temp. flagvariable

;START
_remoteENTRY:
	;zuerst entry conditions prfen...
	lds	r19,SEflagVARa		;serial flag variable A laden
	lds	r22,SEflagVARb		; "             "     B
	lds	r16,SEflagVARc		; "             "     C
	;WICHTIG !serielles if enabled ?
	sbrs	r19,SEenabled
	rjmp		_remoteBACKz		;serielle module disabled
	;WICHTIG ! frame aus buffer noch nicht verschickt
	sbrc	r19,TXframe
	rjmp	_remoteBACKz		; "             "            "         "
	;WICHTIG !serielles if noch busy
	sbrc	r19,SEbusy
	rjmp	_remoteBACKz		;aktiver bertragung

	sbrc	r19,TXack
	rjmp	_remoteBACKz		;aktiver bertragung

	;WICHTIG ! vorbereitung im sercom luft
	sbrc	r22,newTX
	rjmp	_remoteBACKz
	;wtack...
	sbrc	r22,WTack
	rjmp	_remoteBACKz
	;requestanforderung im sercom luft noch...
	sbrc	r22,reqTX
	rjmp	_remoteBACKz
   	;noch ein twi-job zu erledigen, dann kein neues frame !
    lds     r22,TWIstatus
    sbrc    r22,doTWI 
    rjmp    _remoteBACKz
	;noch aktiv?
	lds	r22,comFLAGspi		;flagvariable laden
	sbrc	r22,spiWORKIN		
	rjmp	_remoteBACKz


;----------------------------------------------------------------------------------------------
	;hier remote conditions prfen
	lds	r16,remCNT
	lds	r17,remFLAG
	;off sequenz starten (aus slave)?
	sbrc	r17,RToff
	rjmp	_remoteOFFstart		;durch remote-slave gesetzt == off
	sbrs	r17,RTon			;remote on
	rjmp	_remoteOFF			;remote off
	;on... group remote ?
	sbrc	r17,RTgroup			;1=	group remote on
	rjmp	_remoteBACKz		;ja = zurck !
	;master / slave ?	
	sbrs	r17,RTmaster
	rjmp	_remoteSLAVE		;remote on & slave
	rjmp	_remoteMASTER		;remote on & master









;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;mastermode
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;master sendet remote 
;befehl zum slave
_remoteMASTER:
	sbrc	r17,RTactivM			;prfe ob slave diesen master bereits besttigt hat ?
	rjmp	_remoteMASTERdataWAIT	;=1 remote master besttigt...	
	sbrs	r17,RTactivMstart	
	rjmp	_remoteTOSLAVEloop		;=0 remote on an slave versenden
	rjmp	_remoteTOSLAVEstart		;=1 leitet die startsequenz ein (defaults...)...




	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;STEP 1
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;RTon=1
	;RTmaster =1
	;RTactivMstart =1
	;RTactivM =0
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;start values setzen
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_remoteTOSLAVEstart:
	cbr	r17,1<<RTactivMstart	;startsequenz flag =0
	;fail counter =0
	clr		r16
	sts		remFAILcntL,r16
	sts		remFAILcntH,r16
	;repeat counter =5
	ldi	r16,5
	sts	remWTloop,r16
	;prepare f. off-sequence
	ldi	r16,140	;30
	sts	remCNT,r16
	jmp	_remoteBACK





	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;STEP 2
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;RTon=1
	;RTmaster =1
	;RTactivMstart =0
	;RTactivM =0
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;remote on an slave versenden // master er-
	;wartet RTactivM=1 als besttigung 
	;INFO: besttigung muss innerhalb timeout-sequ.
	;kommen !
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_remoteTOSLAVEloop:
	;fail counter prfen
	lds		yl,remFAILcntL
	lds		yh,remFAILcntH
	ldi		zl,low(remFAILslave)	;1000
	ldi		zh,high(remFAILslave)
	cp		yl,zl
	cpc		yh,zh
	brsh	_remoteMASTERsndY	;
	;fail counter +1
	adiw	yh:yl,1
	sts		remFAILcntL,yl
	sts		remFAILcntH,yh
	jmp	_remoteBACK
	;
_remoteMASTERsndY:	
	clr		r16
	sts		remFAILcntL,r16
	sts		remFAILcntH,r16
	;loop counter prfen
	lds	r16,remWTloop
	tst	r16
	breq	_remoteMASTERsndKILL
	dec	r16
	sts	remWTloop,r16

	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;remGLOBflag manipulieren
	;-> werden ins remFLAG des slave kopiert
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	clr	r16
	sbr	r16,1<<RTon				;remote in senden
	sbr	r16,1<<RTactivSstart	;remote slave startsequenz 
	sbr	r16,1<<RTactivMstart	;remote master startsequenz 
	sbr	r16,1<<RTactivS			;remote activ slave setzen
	sts	remGLOBflag,r16
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;--------------------------
;remote on frame generieren
call	_REM010framer
;--------------------------
	;und fertig
	jmp	_remoteBACK



;~~~~~~~~~~~~~~~~~~~~~~~~~~~
_remoteMASTERsndKILL:
	ldi	r16,30
	sts	remCNT,r16
	;repeat loop
	ldi	r16,3
	sts	remSLloop,r16
	;remote off
	clr	r17
	;counter default
	clr		r16
	sts		remFAILcntL,r16
	sts		remFAILcntH,r16
	jmp	_remoteOFF
;~~~~~~~~~~~~~~~~~~~~~~~~~~~










	


	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;STEP 3
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;RTon=1
	;RTmaster =1
	;RTactivSstart =1
	;RTactivMstart =1
	;RTactivM =1
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;slave hat master besttigt und entsprechende
	;flags gesetzt
	;INFO: RTactivMstart = 1 signalisiert das laden 
	;						 der timeout values
	;	   RTactivSstart = 1 erwartet erstmalig slave
	;						 daten
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_remoteMASTERdataWAIT:
	sbrs	r17,RTactivMstart
	rjmp	_remoteMASTERok		;start values gesetzt

	;statusflag lschen
	cbr		r17,1<<RTactivMstart

	;fail counter =0
	clr		r16
	sts		remFAILcntL,r16
	sts		remFAILcntH,r16
	;repeat counter =5
	ldi	r16,5
	sts	remWTloop,r16
	jmp	_remoteBACK
	



	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;STEP 4
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;RTon=1
	;RTmaster =1
	;RTactivSstart =1
	;RTactivMstart =0
	;RTactivM =1
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;slave hat master besttigt und entsprechende
	;flags gesetzt
	;INFO: RTactivSstart = 1 erwartet erstmalig slave
	;						 daten	   
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


_remoteMASTERok:
	sbrs	r17,RTactivSstart
	rjmp	_remoteMASTERcom		;alles ok - erstmalige slave daten empfangen

	lds		r16,comFLAGspiREM
	sbrs	r16,newSPIsndR
	rjmp	_remoteMASTERokWT	;nein - noch keine gltigen daten vom slave an den master !
	;ja! daten vom slave fr den master !
	cbr		r16,1<<newSPIsndR
	sts		comFLAGspiREM,r16

	;status flag lschen
	cbr		r17,1<<RTactivSstart

	;comFLAGS manipulieren !
	clr	r16
	sbr	r16,1<<spiMready	;beim nchsten durchlauf wird gesendet !
	sbr	r16,1<<newSPIsnd	;neue daten zum hif versenden !
	sts	comFLAGspi,r16		;clr spiMready=0
	;
	jmp	_remoteBACK
	;INFO: weitere ausfhrung im spiM !



_remoteMASTERokWT:
	;fail counter prfen
	lds		yl,remFAILcntL
	lds		yh,remFAILcntH
	ldi		zl,low(remFAILstB)		;3000
	ldi		zh,high(remFAILstB)
	cp		yl,zl
	cpc		yh,zh
	brsh	_remoteMASTERsndKILL	;timeout !!!
	;fail counter +1
	adiw	yh:yl,1
	sts		remFAILcntL,yl
	sts		remFAILcntH,yh
	jmp	_remoteBACK












	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;STEP 5
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;RTon=1
	;RTmaster =1
	;RTactivSstart =0
	;RTactivMstart =0
	;RTactivM =1
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;startsequenz abgeschlossen - kommunikation
	;luft
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

_remoteMASTERcom:
	;sind daten vom slave im speicher ?
	lds		r16,comFLAGspiREM
	sbrs	r16,newSPIsndR
	rjmp	_remoteMASTERcomB	;nein - keine gltigen daten vom slave an den master !
	;ja! noch daten vom slave fr den master !
	cbr		r16,1<<newSPIsndR
	sts		comFLAGspiREM,r16
	;
	ldi	r16,5
	sts	remWTloop,r16
	;
	;***************************
	;wait flag lschen
	;...sind ja daten gekommen !
	lds		r16,HIFremFL
	cbr		r16,1<<HIFfailWT
	sts		HIFremFL,r16

	;***************************
	;comFLAGS manipulieren !
	clr	r16
	sbr	r16,1<<spiMready	;beim nchsten durchlauf wird gesendet !
	sbr	r16,1<<newSPIsnd	;neue daten zum hif versenden !
	sts	comFLAGspi,r16		;clr spiMready=0
	;
	jmp	_remoteBACK
	;INFO: weitere ausfhrung im spiM !






_remoteMASTERcomB:
	;nun z. slave senden
	;wenn HIFremFL<newSPIsnd>=0
	lds	r16,HIFremFL
	sbrs	r16,fromHIFrem		;neuen transfer zum Slave System freigegeben
	rjmp	_remoteMASTERcomC	;prfe ob auf daten vom slave gewartet wird !
	;jetzt ausfhrung == lschen !
	cbr		r16,1<<fromHIFrem
	;nun wait-flag setzen <=> erwarte antwort vom slave
	sbr		r16,1<<HIFfailWT
	sts		HIFremFL,r16
	;
						;------------------------------------
						;systemdaten zum slavehif
						call	_REM040framer
						;------------------------------------

	;*********************************************************
	;daten nun vom master -> slave hif
	;erwartet anschlieend antwort
	;falls nicht: diese daten nach fail time nocmals schicken
	;remFAIL	=	9090	;0,5 s
	clr		r16
	sts		remFAILcntL,r16
	sts		remFAILcntH,r16
	;*********************************************************

	;WICHTIG:dieses flags signalisieren dem slave gltige hif-daten zur ausfhrung!	
	lds	r16,comFLAGspiREM
	sbr	r16,1<<newSPIdataR
	sts	 comFLAGspiREM,r16
	jmp	_remoteBACK




;--------------------------------------------------------------------------------------------------------
	;timeout check !
_remoteMASTERcomC:
	lds		r16,HIFremFL
	sbrs	r16,HIFfailWT
	rjmp	_remoteMASTERcomD	;warte nicht auf daten (ruhezustand)
	;fail counter prfen
	lds		yl,remFAILcntL
	lds		yh,remFAILcntH
	ldi		zl,low(remFAILmaster)	;remFAILmaster = 250
	ldi		zh,high(remFAILmaster)
	cp		yl,zl
	cpc		yh,zh
	brsh	_remoteMASTERcomE	;repeat !
	;fail counter +1
	adiw	yh:yl,1
	sts		remFAILcntL,yl
	sts		remFAILcntH,yh
_remoteMASTERcomD:
	jmp	_remoteBACK

	;repeat
_remoteMASTERcomE:
	;wait counter setzen
	lds r16,remWTloop
	dec	r16
	sts	remWTloop,r16
	tst	r16
	brne	_remoteMASTERcomF
	;time out - kill
	ldi	r16,10
	sts	remWTloop,r16
	jmp	_remoteMASTERsndKILL
	;
	;->repeat
_remoteMASTERcomF:
	sts	remWTloop,r16
	lds	r16,HIFremFL
	sbr	r16,1<<fromHIFrem		;wiederholten transfer zum Slave System freigegeben
	sts	HIFremFL,r16
	jmp	_remoteBACK





























;~~~~~~~~~~~~~~~~~~~~~--------------------------------------------------------------------------------------------------
;slavemode
;~~~~~~~~~~~~~~~~~~~~~--------------------------------------------------------------------------------------------------

_remoteSLAVE:
	sbrs	r17,RTactivS
	rjmp	_remoteSLAVEkill		;nur RTon ist undefinierbar !
	sbrc	r17,RTactivSstart
	rjmp	_remoteSLAVEtoMSTRstart	;=1 durch master gesetzt <=> remote on & slavemode empfangen defaults laden & RTactivM schicken
	sbrc	r17,RTactivMstart
	rjmp	_remoteSLAVEtoMSTR		;=1 durch master gesetzt <=> remote on & slavemode empfangen erstmalig daten an master schicken
	rjmp	_remoteSLAVEact			;=0 kommunikation luft !






	

	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;STEP 1
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;RTon=1
	;RTactivS =1
	;RTactivSstart =1
	;RTactivMstart =1
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;start values setzen & RTactivM an master schicken
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;
_remoteSLAVEtoMSTRstart:

	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;remGLOBflag manipulieren
	;-> werden ins remFLAG des master kopiert
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	clr	r16
	sbr	r16,1<<RTon				;remote in senden
	sbr	r16,1<<RTactivSstart	;remote slave startsequenz 
	sbr	r16,1<<RTactivMstart	;remote master startsequenz 
	sbr	r16,1<<RTactivM			;remote activ slave setzen
	sbr	r16,1<<RTmaster			;remote master
	sts	remGLOBflag,r16
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	;--------------------------------------
	;remGLOBflag(slave) -> remFLAG(master)
	call	_REM030framer
	;--------------------------------------

	;hif default
	clr	zh
	sts	HIFremFL,zh		;auch in die remote Flagvariable kopieren
	
	;counter default
	clr		r16
	sts		remFAILcntL,r16
	sts		remFAILcntH,r16

	;loop counter =3
	ldi	r16,3
	sts	remSLloop,r16

	;statusflag lschen 
	cbr	r17,1<<RTactivSstart

	jmp	_remoteBACK	















	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;STEP 2
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;RTon=1
	;RTactivS =1
	;RTactivSstart =0
	;RTactivMstart =1
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;erstmalig daten an master schicken
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;

_remoteSLAVEtoMSTR:
	;warte...
	lds		yl,remFAILcntL
	lds		yh,remFAILcntH
	ldi		zl,low(remFAIL)
	ldi		zh,high(remFAIL)
	cp		yl,zl
	cpc		yh,zh
	brsh	_remoteSLAVEsndMSTR		;jetzt senden
	;fail counter +1
	adiw	yh:yl,1
	sts		remFAILcntL,yl
	sts		remFAILcntH,yh
	jmp	_remoteBACK	



	;jetzt senden (3x)
_remoteSLAVEsndMSTR:		
	lds		r16,remSLloop
	tst		r16
	breq	_remoteSLAVEsndMSTRready		;kommunikation luft (hoffentlich...)
	dec		r16	
	sts	remSLloop,r16
	;counter default
	clr		r16
	sts		remFAILcntL,r16
	sts		remFAILcntH,r16

	;------------------------------------
	;systemdaten zum masterhif
	call	_REM040framer
	;------------------------------------
	;WICHTIG:diese flags signalisieren dem master gltige hif-daten !
	lds	r16,comFLAGspiREM
	sbr	r16,1<<newSPIsndR
	sts	comFLAGspiREM,r16
	;
	jmp	_remoteBACK

_remoteSLAVEsndMSTRready:
	;rem-flag wieder lschen
	cbr	r17,1<<RTactivMstart 
	;counter default
	clr		r16
	sts		remFAILcntL,r16
	sts		remFAILcntH,r16
	;loop default f. kommunikation
	ldi	r16,10
	sts	remSLloop,r16
	jmp	_remoteBACK	



	;slave remote off
_remoteSLAVEkill:
	sbr	r17,1<<RToff
	jmp	_remoteOFFstart















	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;STEP 3
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;RTon=1
	;RTactivS =1
	;RTactivSstart =0
	;RTactivMstart =0
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;daten kommunikation mit master
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;
_remoteSLAVEact:
	;remote / spi steuerflags
	lds		r16,HIFremFL
	sbrs	r16,toHIFrem	;sende daten z. master-hif (im hif generiert !)
	rjmp	_remoteSLAVEactb		;kein neuer job...aber vielleicht noch ein alter ?
	;jetzt ausfhrung == lschen !
	cbr		r16,1<<toHIFrem
	sts		HIFremFL,r16
						
						;------------------------------------
						;systemdaten zum masterhif
						call	_REM040framer
						;------------------------------------
	;WICHTIG:diese flags signalisieren dem master gltige hif-daten !
	lds	r16,comFLAGspiREM
	sbr	r16,1<<newSPIsndR
	sts	comFLAGspiREM,r16
	;
	jmp	_remoteBACK


	;----------------------------------------------------------------
	;Step 3B noch aktuelle daten vom master an den slave ?
	;----------------------------------------------------------------
_remoteSLAVEactb:

	lds		r16,comFLAGspiREM
	sbrs	r16,newSPIdataR
	rjmp	_remoteBACK	;nein - keine gltigen daten vom master an den slave !
	;ja! noch daten vom master fr den slave !
	cbr		r16,1<<newSPIdataR
	sts		comFLAGspiREM,r16
	;comFLAGS manipulieren !
	clr	r16
	sbr	r16,1<<spiMready	;beim nchsten durchlauf wird gesendet !
	sbr	r16,1<<newSPIdata	;neue daten bers spi modul zum system !
	sts	comFLAGspi,r16		;clr spiMready=0
	;
	jmp	_remoteBACK
	;INFO: weitere ausfhrung im spiM !




























;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~--------------------------------------------------------------------------------
;remote off (master / timeout)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~--------------------------------------------------------------------------------
_remoteOFF:
	cpi	r16,30
	brne	_remoteOFFslave
	rjmp	_remoteOFFtiout

_remoteOFFslave:
	cpi	r16,140
	brne	_remoteBACKx
	rjmp	_remoteOFFslaveX






;----------------------------------------------------
;master timeout remote off //30
;----------------------------------------------------
_remoteOFFtiout:
	lds		yl,remFAILcntL
	lds		yh,remFAILcntH
	ldi		zl,low(remFAIL)
	ldi		zh,high(remFAIL)
	cp		yl,zl
	cpc		yh,zh
	brsh	_remoteOFFtioutREP		;jetzt senden
	;fail counter +1
	adiw	yh:yl,1
	sts		remFAILcntL,yl
	sts		remFAILcntH,yh
	jmp	_remoteBACK	



	;jetzt senden (5x)
_remoteOFFtioutREP:		
	lds		r16,remSLloop
	tst		r16
	breq	_remoteOFFslaveX		;ende
	dec		r16	
	sts	remSLloop,r16
	;counter default
	clr		r16
	sts		remFAILcntL,r16
	sts		remFAILcntH,r16
;----------------------------------------------------
		;hier remote off generieren
		;setze remote-flag
		;(sende anschlieen RToff-frame z. slave oder master!
		call	_REM020framer
;----------------------------------------------------
	;remote glob flags
	clr	r16
	sts	remGLOBflag,r16
	;
	rjmp _remoteBACK











;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;master off
;unmittelbar nach off durch slave
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_remoteOFFslaveX:
	;remFlag=0
	clr	r17
	;cnt=0
	clr	r16
	sts	remCNT,r16
	;spi flags manipulieren
	clr	r16
	sbr	 r16,1<<exeSPIdata
	sbr	 r16,1<<spiMready
	sts	 comFLAGspi,r16
	;
_remoteBACKx:
	;HIFremFL =0
	clr	r16
	sts	HIFremFL,r16
	clr		r16
	sts		remFAILcntL,r16
	sts		remFAILcntH,r16
	;TEST
	sts	comFLAGspiREM,r16



	ldi	r16,5
	sts	remSLloop,r16

	rjmp _remoteBACK
;-----------------------------------------------------------------------------------------------








;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~--------------------------------------------------------------------------------
;remote off (durch slave) // nur bei RToff=1
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~--------------------------------------------------------------------------------


_remoteOFFstart:
	lds		yl,remFAILcntL
	lds		yh,remFAILcntH
	ldi		zl,low(remFAIL)
	ldi		zh,high(remFAIL)
	cp		yl,zl
	cpc		yh,zh
	brsh	_remoteOFFstartREP		;jetzt senden
	;fail counter +1
	adiw	yh:yl,1
	sts		remFAILcntL,yl
	sts		remFAILcntH,yh
	jmp	_remoteBACK	



	;jetzt senden (5x)
_remoteOFFstartREP:		
	lds		r16,remSLloop
	tst		r16
	breq	_remoteOFFstartREADY		;ende
	dec		r16	
	sts	remSLloop,r16
	;counter default
	clr		r16
	sts		remFAILcntL,r16
	sts		remFAILcntH,r16



					;----------------------------------------------------
							;hier remote off generieren
							;setze remote-flag
							;(sende anschlieen RToff-frame z. slave oder master!
							call	_REM020framer
					;----------------------------------------------------
	;remote glob flags
	clr	r16
	sts	remGLOBflag,r16
	;
	rjmp _remoteBACK



	;stop sequence fertig
_remoteOFFstartREADY:
	clr	r16
	sts	remCNT,r16
	;HIFremFL =0
	sts	HIFremFL,r16
	;TEST
	sts	comFLAGspiREM,r16
	;remFLAG =0
	clr	r17
	;prozPSC=1
	;progPSC=0
	ldi	r16,1	
	sts	prozPSC,r16
	clr	r16
	sts	progPSC,r16
	;ausfhren
	clr	r16
	sbr	r16,1<<exeSPIdata
	sbr	r16,1<<spiMready
	sts	comFLAGspi,r16
	ldi	r16,5
	sts	remSLloop,r16
	rjmp _remoteBACK








;----------------------------------------------------
;lade parameter fr ,remote on'
;...frame zum slave senden !
;----------------------------------------------------
_REM010framer:
	call	_REMinit
	;lade FRAMESIZE
	ldi		zh,high(_REMonTBL*2)
	ldi		zl,low(_REMonTBL*2)
	adiw	zh:zl,5
	lpm		r20,z		;framesize
	sts		FRAMEsize,r20	
	;bestimme copysize
	ldi		r20,25		;copysize
	;lade FLASH-TABLE STARTADRESS
	ldi		zh,high(_REMonTBL*2)
	ldi		zl,low(_REMonTBL*2)
	;kopiere FLASH-TABLE NACH TXbuffer
_REM010framerLOOP:
	lpm		r16,z+
	st		y+,r16
	dec		r20
	tst		r20
	brne	_REM010framerLOOP
	;lha slave-adresse einfgen
	ldi		yl, low(TXbufferST)	
	ldi		yh, high(TXbufferST)
	adiw	yh:yl,1
	lds		r20,remSLAVE
	st		y,r20
	;lha master-adresse einfgen
	adiw	yh:yl,2
	lds		r20,remMASTER
	st		y,r20
	;fertig...
	ret


;----------------------------------------------------
;lade parameter fr ,remote off'
;...frame zum slave senden !
;----------------------------------------------------
_REM020framer:
	call	_REMinit
	;lade FRAMESIZE
	ldi		zh,high(_REMoffTBL*2)
	ldi		zl,low(_REMoffTBL*2)
	adiw	zh:zl,5
	lpm		r20,z		;framesize
	sts		FRAMEsize,r20	
	;bestimme copysize
	ldi		r20,20		;copysize
	;lade FLASH-TABLE STARTADRESS
	ldi		zh,high(_REMoffTBL*2)
	ldi		zl,low(_REMoffTBL*2)
	;kopiere FLASH-TABLE NACH TXbuffer
_REM020framerLOOP:
	lpm		r16,z+
	st		y+,r16
	dec		r20
	tst		r20
	brne	_REM020framerLOOP
	;lha slave-adresse einfgen
	ldi		yl, low(TXbufferST)	
	ldi		yh, high(TXbufferST)
	adiw	yh:yl,1
	lds		r20,remSLAVE
	st		y,r20
	;lha master-adresse einfgen
	adiw	yh:yl,2
	lds		r20,remMASTER
	st		y,r20
	;fertig...
	ret

;----------------------------------------------------
;lade parameter fr ,remote activ'
;...frame vom slave z. master senden !
;----------------------------------------------------
_REM030framer:
	call	_REMinit
	;lade FRAMESIZE
	ldi		zh,high(_REMactivTBL*2)
	ldi		zl,low(_REMactivTBL*2)
	adiw	zh:zl,5
	lpm		r20,z		;framesize
	sts		FRAMEsize,r20	
	;bestimme copysize
	ldi		r20,15		;copysize
	;lade FLASH-TABLE STARTADRESS
	ldi		zh,high(_REMactivTBL*2)
	ldi		zl,low(_REMactivTBL*2)
	;kopiere FLASH-TABLE NACH TXbuffer
_REM030framerLOOP:
	lpm		r16,z+
	st		y+,r16
	dec		r20
	tst		r20
	brne	_REM030framerLOOP
	;lha slave-adresse einfgen
	ldi		yl, low(TXbufferST)	
	ldi		yh, high(TXbufferST)
	adiw	yh:yl,1
	lds		r20,remSLAVE
	st		y,r20
	;lha master-adresse einfgen
	adiw	yh:yl,2
	lds		r20,remMASTER
	st		y,r20
	;fertig...
	ret


;----------------------------------------------------
;lade parameter fr ,sndREMspicode'
;...frame vom master z. slave senden !
;----------------------------------------------------
_REM040framer:
	call	_REMinit
	;lade FRAMESIZE
	ldi		zh,high(_REMspiTBL*2)
	ldi		zl,low(_REMspiTBL*2)
	adiw	zh:zl,5
	lpm		r20,z		;framesize
	sts		FRAMEsize,r20	
	;bestimme copysize
	ldi		r20,15		;copysize
	;lade FLASH-TABLE STARTADRESS
	ldi		zh,high(_REMspiTBL*2)
	ldi		zl,low(_REMspiTBL*2)
	;kopiere FLASH-TABLE NACH TXbuffer
_REM040framerLOOP:
	lpm		r16,z+
	st		y+,r16
	dec		r20
	tst		r20
	brne	_REM040framerLOOP
	;lha slave-adresse einfgen
	ldi		yl, low(TXbufferST)	
	ldi		yh, high(TXbufferST)
	adiw	yh:yl,1
	lds		r20,remSLAVE
	st		y,r20
	;lha master-adresse einfgen
	adiw	yh:yl,2
	lds		r20,remMASTER
	st		y,r20
	;fertig...
	ret

;------------------------------------------------------
;REMinit - remoteframer initialisieren
;------------------------------------------------------
_REMinit:
	;framebuilder startet...
	lds	r16,SEflagVARc
	sbr	r16,1<<FRbuild
	sts	SEflagVARc,r16
	;bertragung anschlieend starten...	
	lds	r22,SEflagVARb
	sbr	r22,1<<newTX
	sts	SEflagVARb,r22
	;lade SRAM-buffer-startadresse
	ldi	yl, low(TXbufferST)	
	ldi	yh, high(TXbufferST)	
	;zurck
	ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~-------------------------------------------------------------------------
;HOME
;----------------------------------------------------------------------------------------------------------------------
_remoteBACK:
	sts	remFLAG,r17
_remoteBACKz:
	ret



