;----------------------------------------------
;interrupt based uart
;----------------------------------------------
;integrated FiFo-Buffer / Size 0xff
;----------------------------------------------
;used var's:
;fifoIN 	<=> 	in  counter
;fifoOUT 	<=> 	out counter
;fifoVAR	<=>		flag var
;
;used flags:
;fifoNEW	<=> 	new data in fifo <flag var>
;fifoERR	<=>	fifo error / rx-error flags detected
;----------------------------------------------

;used def's:
;
;.def	fifoIN		;fifo in  adress
;.def	fifoOUT		;fifo out adress
;.def	fifoVAR	
;.def	fifoSEG		;fifo start segment
;----------------------------------------------
	
	;rx interrupt handler
	;! systemtime must be corrected 
	;  because of loosen interrupt 
	;  handler time.... 
	;  ->calculation base: intruction execution time (16MHz <=> 62,5ns/cycle)
	;                      
uartINTrx:

;	push	tiFLAG
;	push	slotCNT
	push	r5
	in		r5,sreg		;save sreg to r5
	;request waiting..
	lds	r18,SEflagVARb	
	sbrc	r18,reqTX		;request vorbereitung luft im sercom !!!
	rjmp	_fifo_back		;keine rx-daten beachten ==taub
	lds		r18,fifoVAR
	;check uart error flags
	sbic	ucsr0a,fe0				;<1>= framing error (missing stop bit)
	rjmp	_errFIFOdata		;...ERROR 
	sbic	ucsr0a,dor0			;<1>= buffer overrun (udr0 not taken)
	rjmp	_errFIFOdata		;...ERROR
	rjmp	_noerrFIFOdata	
	;setze FIFOerr flag
_errFIFOdata:
	sbr		r18,1<<fifoERR
	;
_noerrFIFOdata:
	sbr		r18,1<<fifoNEW
	sts		fifoVAR,r18
	in		r4,udr0		;rx data to r4
	;12
	;...calculate 
	;fifoIN adress
	lds		zl,fifoIN
	mov		r18,zl
	clr		zh			
	subi		zl,low(-fifoSEG)
	sbci		zh,high(-fifoSEG)
	st		z,r4		;store received data to fifo
	inc		r18
	sts		fifoIN,r18	;store new counter value <=> points
					;to the next empty memory-space
_fifo_back:
	;12
	out		sreg,r5
	pop		r5
;	pop		slotCNT
;	pop		tiFLAG
	reti
	;4
	;=39+4(call..)=43*62,5ns=2,679s
